diff -Nru sogo-5.0.1/Tools/SOGoToolExpireUserSessions.m sogo-5.2.0/Tools/SOGoToolExpireUserSessions.m
--- sogo-5.0.1/Tools/SOGoToolExpireUserSessions.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/Tools/SOGoToolExpireUserSessions.m	2021-08-18 21:35:57.000000000 +0200
@@ -1,6 +1,6 @@
 /* SOGoToolExpireUserSessions.m - this file is part of SOGo
  *
- * Copyright (C) 2012-2020 Inverse inc.
+ * Copyright (C) 2012-2021 Inverse inc.
  *
  * This file is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -32,6 +32,7 @@
 #import <NGExtensions/NSNull+misc.h>
 
 #import <SOGo/NSString+Utilities.h>
+#import <SOGo/SOGoSession.h>
 
 #import "SOGoTool.h"
 
@@ -63,20 +64,20 @@
   BOOL rc;
   EOAdaptorChannel *channel;
   GCSChannelManager *cm;
-  NSArray *attrs, *qValues;
+  NSArray *attrs;
   NSDictionary *qresult;
   NSException *ex;
-  NSString *sql, *sessionsFolderURL;
+  NSString *sql, *sessionsFolderURL, *sessionID;
   NSURL *tableURL;
   NSUserDefaults *ud;
 
   unsigned int now, oldest;
-  int sessionsToDelete;
 
-  rc=YES;
+  rc = YES;
   ud = [NSUserDefaults standardUserDefaults];
   now = [[NSCalendarDate calendarDate] timeIntervalSince1970];
   oldest = now - (nbMinutes * 60);
+  sessionID = nil;
 
   sessionsFolderURL = [ud stringForKey: @"OCSSessionsFolderURL"];
   if (!sessionsFolderURL)
@@ -93,56 +94,43 @@
   {
     /* FIXME: nice error msg */
     NSLog(@"Can't aquire channel");
-    return rc=NO;
+    return rc = NO;
   }
 
-  sql = [NSString stringWithFormat: @"SELECT count(*) FROM %@ WHERE c_lastseen <= %d",
-                        [tableURL gcsTableName], oldest];
+  sql = [NSString stringWithFormat: @"SELECT c_id FROM %@ WHERE c_lastseen <= %d",
+                  [tableURL gcsTableName], oldest];
   ex = [channel evaluateExpressionX: sql]; 
   if (ex)
   {
     NSLog(@"%@", [ex reason]);
     [ex raise];
-    return rc=NO;
+    return rc = NO;
   }
 
   attrs = [channel describeResults: NO];
-  /* only one row */
-  qresult = [channel fetchAttributes: attrs withZone: NULL];
-  qValues = [qresult allValues];
-  sessionsToDelete = [[qValues objectAtIndex: 0] intValue];
-  if (sessionsToDelete)
-  {
-    if (verbose)
-      NSLog(@"Will be removing %d sessions", sessionsToDelete);
-    [channel cancelFetch];
-    sql = [NSString stringWithFormat: @"DELETE FROM %@ WHERE c_lastseen <= %d",
-                        [tableURL gcsTableName], oldest];
-    if (verbose)
-      NSLog(@"Removing sessions older than %d minute(s)", nbMinutes);
-    ex = [channel evaluateExpressionX: sql]; 
-    if (ex)
+  while ((qresult = [channel fetchAttributes: attrs withZone: NULL]))
     {
-      NSLog(@"An exception occured while deleting old sessions: %@", [ex reason]);
-      [ex raise];
-      return rc=NO;
+      sessionID = [qresult objectForKey: @"c_id"];
+      if (sessionID)
+        {
+          if (verbose)
+            NSLog(@"Removing session %@", sessionID);
+          [SOGoSession deleteValueForSessionKey: sessionID];
+        }
     }
-  }
-  else
-  {
-    if (verbose)
-      NSLog(@"No session to remove");
-  }
-
   [cm releaseChannel: channel  immediately: YES];
+
+  if (verbose && sessionID == nil)
+    NSLog(@"No session to remove");
+
   return rc;
 }
 
 - (BOOL) run
 {
   BOOL rc;
-  int sessionExpireMinutes=0;
-  
+  int sessionExpireMinutes = -1;
+
   rc = NO;
 
   if ([arguments count])
@@ -150,7 +138,7 @@
     sessionExpireMinutes = [[arguments objectAtIndex: 0] intValue];
   }
 
-  if (sessionExpireMinutes > 0)
+  if (sessionExpireMinutes >= 0)
   {
     rc = [self expireUserSessionOlderThan: sessionExpireMinutes];
   }
diff -Nru sogo-5.0.1/Tools/SOGoToolRenameUser.m sogo-5.2.0/Tools/SOGoToolRenameUser.m
--- sogo-5.0.1/Tools/SOGoToolRenameUser.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/Tools/SOGoToolRenameUser.m	2021-08-18 21:35:57.000000000 +0200
@@ -413,6 +413,7 @@
 }
 
 - (void) _updateLocalACLsForPath: (NSString *) path
+                     andFolderID: (NSString *) folderID
                      fromSQLUser: (NSString *) sqlFromUserID
                        toSQLUser: (NSString *) sqlToUserID
 {
@@ -443,8 +444,12 @@
                                 sqlToUserID, rest];
       location = [folder aclLocation];
       ac = [cm acquireOpenChannelForURL: location];
-      sql = [NSString stringWithFormat: @"UPDATE %@ SET c_object = '%@'",
-                      [location gcsTableName], newObjectPath];
+      if ([GCSFolderManager singleStoreMode])
+        sql = [NSString stringWithFormat: @"UPDATE %@ SET c_object = '%@' WHERE c_folder_id = %@",
+                        [location gcsTableName], newObjectPath, folderID];
+      else
+        sql = [NSString stringWithFormat: @"UPDATE %@ SET c_object = '%@'",
+                        [location gcsTableName], newObjectPath];
       [ac evaluateExpressionX: sql];
       [cm releaseChannel: ac  immediately: YES];
     }
@@ -470,37 +475,48 @@
   sqlFromUserID = [fromUserID asSafeSQLString];
   sqlToUserID = [toUserID asSafeSQLString];
 
-  sql = [NSString stringWithFormat: @"SELECT c_path FROM %@"
+  sql = [NSString stringWithFormat: @"SELECT c_path, c_folder_id FROM %@"
                   @" WHERE c_path2 = '%@'",
                   [folderLocation gcsTableName], sqlToUserID];
   [fc evaluateExpressionX: sql];
   attrs = [fc describeResults: NO];
   while ((row = [fc fetchAttributes: attrs withZone: NULL]))
     [self _updateLocalACLsForPath: [row objectForKey: @"c_path"]
+                      andFolderID: [row objectForKey: @"c_folder_id"]
                       fromSQLUser: sqlFromUserID
                         toSQLUser: sqlToUserID];
   [fc cancelFetch];
   [cm releaseChannel: fc  immediately: YES];
 }
 
-- (void) _updateForeignACLsForLocation: (NSString *) locationString
-                           fromSQLUser: (NSString *) sqlFromUserID
-                             toSQLUser: (NSString *) sqlToUserID
+- (void) _updateForeignACLsForPath: (NSString *) path
+                       andFolderID: (NSString *) folderID
+                       fromSQLUser: (NSString *) sqlFromUserID
+                         toSQLUser: (NSString *) sqlToUserID
 {
-  NSAutoreleasePool *pool;
-  NSURL *location;
   GCSChannelManager *cm;
+  GCSFolder *folder;
+  GCSFolderManager *fm;
   EOAdaptorChannel *tc;
+  NSAutoreleasePool *pool;
   NSString *sql;
+  NSURL *location;
 
   pool = [NSAutoreleasePool new];
 
-  cm = [[GCSFolderManager defaultFolderManager] channelManager];
-
-  location = [NSURL URLWithString: locationString];
+  fm = [GCSFolderManager defaultFolderManager];
+  cm = [fm channelManager];
+  folder = [fm folderAtPath: path];
+  location = [folder aclLocation];
 
   tc = [cm acquireOpenChannelForURL: location];
-  sql = [NSString stringWithFormat: @"UPDATE %@ SET c_uid = '%@'"
+  if ([GCSFolderManager singleStoreMode])
+    sql = [NSString stringWithFormat: @"UPDATE %@ SET c_uid = '%@'"
+                     @" WHERE c_uid = '%@'",
+                     [location gcsTableName],
+                     sqlToUserID, sqlFromUserID];
+  else
+    sql = [NSString stringWithFormat: @"UPDATE %@ SET c_uid = '%@'"
                      @" WHERE c_uid = '%@'",
                      [location gcsTableName],
                      sqlToUserID, sqlFromUserID];
@@ -527,15 +543,16 @@
   sqlFromUserID = [fromUserID asSafeSQLString];
   sqlToUserID = [toUserID asSafeSQLString];
 
-  sql = [NSString stringWithFormat: @"SELECT c_acl_location FROM %@"
+  sql = [NSString stringWithFormat: @"SELECT c_path, c_folder_id FROM %@"
                   @" WHERE c_path2 != '%@'",
                   [folderLocation gcsTableName], sqlToUserID];
   [fc evaluateExpressionX: sql];
   attrs = [fc describeResults: NO];
   while ((row = [fc fetchAttributes: attrs withZone: NULL]))
-    [self _updateForeignACLsForLocation: [row objectForKey: @"c_acl_location"]
-                            fromSQLUser: sqlFromUserID
-                              toSQLUser: sqlToUserID];
+    [self _updateForeignACLsForPath: [row objectForKey: @"c_path"]
+                        andFolderID: [row objectForKey: @"c_folder_id"]
+                        fromSQLUser: sqlFromUserID
+                          toSQLUser: sqlToUserID];
   [fc cancelFetch];
   [cm releaseChannel: fc  immediately: YES];
 }
diff -Nru sogo-5.0.1/Tools/SOGoToolRestore.m sogo-5.2.0/Tools/SOGoToolRestore.m
--- sogo-5.0.1/Tools/SOGoToolRestore.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/Tools/SOGoToolRestore.m	2021-08-18 21:35:57.000000000 +0200
@@ -95,7 +95,7 @@
 
 - (void) usage
 {
-  fprintf (stderr, "restore [-l|-p|-f/-F folder/ALL|-p] [-c credentialFile] directory user\n\n"
+  fprintf (stderr, "restore [-l|-p|-f/-F folder/ALL] [-c credentialFile] directory user\n\n"
 	   "           directory  the directory where backup files were initially stored\n"
 	   "           user       the user of whom to restore the data\n"
 	   "           -l         flag used to list folders to restore\n"
diff -Nru sogo-5.0.1/Tools/SOGoToolUpdateAutoReply.m sogo-5.2.0/Tools/SOGoToolUpdateAutoReply.m
--- sogo-5.0.1/Tools/SOGoToolUpdateAutoReply.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/Tools/SOGoToolUpdateAutoReply.m	2021-08-18 21:35:57.000000000 +0200
@@ -28,6 +28,7 @@
 #import <GDLContentStore/GCSChannelManager.h>
 #import <GDLContentStore/NSURL+GCS.h>
 
+#import <NGExtensions/NSCalendarDate+misc.h>
 #import <NGExtensions/NSNull+misc.h>
 
 #import <NGObjWeb/WOContext+SoObjects.h>
@@ -157,9 +158,9 @@
   NSString *sql, *profileURL, *user, *c_defaults;
   NSURL *tableURL;
   SOGoSystemDefaults *sd;
-  unsigned int endTime, startTime, now;
+  unsigned int now, endTime, startTime;
 
-  now = [[NSCalendarDate calendarDate] timeIntervalSince1970];
+  now = [[[NSCalendarDate calendarDate] beginOfDay] timeIntervalSince1970];
   sd = [SOGoSystemDefaults sharedSystemDefaults];
   profileURL = [sd profileURL];
   if (!profileURL)
@@ -212,7 +213,7 @@
                       if ([[vacationOptions objectForKey: @"endDateEnabled"] boolValue])
                         {
                           endTime = [[vacationOptions objectForKey: @"endDate"] intValue];
-                          if (endTime <= now)
+                          if (endTime < now)
                             {
                               if ([self updateAutoReplyForLogin: user
 					      withSieveUsername: theUsername
